#include "net_common.h"

int ObjectID;
int bMachineMoving = 0;

void OnCache()
{
	LoadScene("IN05");
	PlayNetGameMusic("s07_castle_bgm");
	SetAudioEnvironment(ENVIRONMENT_CITY);
}

void OnHostGame()
{
	float x, y, z, dx, dy, dz;
	
	for(int i = 0 ; i < 2 ; i++)
	{
		ObjectID = FindSceneItem(NumToStr("SPIKE01_%02d", i));
		GetSceneItemPos(ObjectID, x, y, z);
		GetSceneItemRot(ObjectID, dx, dy, dz);
		SpawnItem(NumToStr("TriggerSpike01_%02d", i), x, y, z+90, dx, dy, dz);
	}
	for(i = 0 ; i < 4 ; i++)
	{
		ObjectID = FindSceneItem(NumToStr("SPIKE02_%02d", i));
		GetSceneItemPos(ObjectID, x, y, z);
		GetSceneItemRot(ObjectID, dx, dy, dz);
		SpawnItem(NumToStr("TriggerSpike02_%02d", i), x, y, z+90, dx, dy, dz);
	}
}

void DOOR_InitItem(int id)
{
	float x, y, z;
	
	GetEntityPos(id, x, y, z);

	SetItemAttrib(id, ITEM_MODEL, "in05door", 1);
	SetItemAttrib(id, ITEM_MOVEPOINT, 2, x, y, z, x, y, z - 190);
	SetItemAttrib(id, ITEM_PHYSICS, ITEM_PHYSICS_NONE);
	SetItemAttrib(id, ITEM_LIFTABLE, 0);
	SetItemAttrib(id, ITEM_PICKABLE, 0);
	SetItemAttrib(id, ITEM_WAITTIME, 0);
	SetItemAttrib(id, ITEM_MOVETYPE, 0);
	SetItemAttrib(id, ITEM_MOVESPEED, 60);
	SetItemAttrib(id, ITEM_NEXTPOINT, 1);
	SetItemAttrib(id, ITEM_HP, 0);
}

void DOOR_OnReach(int id, int np)
{
	if (np == 0)
		SetItemAttrib(id, ITEM_NEXTPOINT, 1);
	else if (np == 1)
		SetItemAttrib(id, ITEM_NEXTPOINT, 0);

	SetItemAttrib(id, ITEM_HP, 0);
}

void SWITCH_InitItem(int id)
{
	SetItemAttrib(id, ITEM_MODEL, "in05switch", 1);
	SetItemAttrib(id, ITEM_PHYSICS, ITEM_PHYSICS_NONE);
	SetItemAttrib(id, ITEM_LIFTABLE, 0);
	SetItemAttrib(id, ITEM_PICKABLE, 0);
	SetItemAttrib(id, ITEM_ROTATEAXIS, 1, 0, 0);
	SetItemAttrib(id, ITEM_ROTATEANGLE, -0.3);
	SetItemAttrib(id, ITEM_ROTATESPEED, -0.3);
	SetItemAttrib(id, ITEM_HP, 0);
}

void SWITCH_OnReach(int id, int np)
{
	if (GetItemAttrib(id, ITEM_HP) == 0)
	{
		SetItemAttrib(id, ITEM_ROTATEANGLE, 0.3);
		SetItemAttrib(id, ITEM_ROTATESPEED, 0.3);
		SetItemAttrib(id, ITEM_HP, 1);
	}
	else
	{
		SetItemAttrib(id, ITEM_ROTATEANGLE, -0.3);
		SetItemAttrib(id, ITEM_ROTATESPEED, -0.3);
		SetItemAttrib(id, ITEM_HP, 0);
	}
}

void SWITCH_00_OnAttack(int id, int charaId, int damage)
{
	ObjectID = FindItem("DOOR_00");
	
	if (GetItemAttrib(ObjectID, ITEM_HP) == 1) return;
	
	// open door	
	SetItemMachine(ObjectID, 1);
	// rotate switch
	SetItemMachine(id, 1);
	SetItemAttrib(ObjectID, ITEM_HP, 1);
}

void SWITCH_01_OnAttack(int id, int charaId, int damage)
{
	ObjectID = FindItem("DOOR_01");
	
	if (GetItemAttrib(ObjectID, ITEM_HP) == 1) return;

	// open door	
	SetItemMachine(ObjectID, 1);	
	// rotate switch
	SetItemMachine(id, 1);
	SetItemAttrib(ObjectID, ITEM_HP, 1);
}

void MoveSpike()
{
	if (bMachineMoving == 0)
	{
		ObjectID = FindItem("SPIKE01_00");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("TRIGGERSPIKE01_00");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("SPIKE01_01");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("TRIGGERSPIKE01_01");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("SPIKE02_00");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("TRIGGERSPIKE02_00");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("SPIKE02_01");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("TRIGGERSPIKE02_01");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("SPIKE02_02");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("TRIGGERSPIKE02_02");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("SPIKE02_03");
		SetItemMachine(ObjectID, 1, 1);
		ObjectID = FindItem("TRIGGERSPIKE02_03");
		SetItemMachine(ObjectID, 1, 1);
		
		ObjectID = FindItem("Switch_02");
		SetItemMachine(ObjectID, 1);
		ObjectID = FindItem("Switch_03");
		SetItemMachine(ObjectID, 1);
		
		bMachineMoving = 1;
	}
}

void SWITCH_02_OnAttack(int id, int charaId, int damage)
{
	if (bMachineMoving)
		return;
		
	MoveSpike();
}

void SWITCH_03_OnAttack(int id, int charaId, int damage)
{
	if (bMachineMoving)
		return;
		
	MoveSpike();
}

void SPIKE01_InitItem(int id)
{
	float x, y, z, dx, dy, dz;
	
	GetEntityPos(id, x, y, z);
	GetEntityDir(id, dx, dy, dz);
	
	SetItemAttrib(id, ITEM_MODEL, "in05spike01", 1);
	SetItemAttrib(id, ITEM_PHYSICS, ITEM_PHYSICS_NONE);
	SetItemAttrib(id, ITEM_LIFTABLE, 0);
	SetItemAttrib(id, ITEM_PICKABLE, 0);
	SetItemAttrib(id, ITEM_MOVEPOINT, 2, x, y, z, x-120*dy, y+120*dx, z);
	SetItemAttrib(id, ITEM_WAITTIME, 0);
	SetItemAttrib(id, ITEM_MOVETYPE, 0);
	SetItemAttrib(id, ITEM_MOVESPEED, 50);
	SetItemAttrib(id, ITEM_NEXTPOINT, 1);
}

void TRIGGERSPIKE01_InitItem(int id)
{
	float x, y, z, dx, dy, dz;
	
	GetEntityPos(id, x, y, z);
	GetEntityDir(id, dx, dy, dz);
	
	SetItemAttrib(id, ITEM_SIZE, 160, 200, 180);
	SetItemAttrib(id, ITEM_PHYSICS, ITEM_PHYSICS_NONE);
	SetItemAttrib(id, ITEM_LIFTABLE, 0);
	SetItemAttrib(id, ITEM_PICKABLE, 0);
	SetItemAttrib(id, ITEM_MOVEPOINT, 2, x, y, z, x-120*dy, y+120*dx, z);
	SetItemAttrib(id, ITEM_WAITTIME, 0);
	SetItemAttrib(id, ITEM_MOVETYPE, 0);
	SetItemAttrib(id, ITEM_MOVESPEED, 50);
	SetItemAttrib(id, ITEM_NEXTPOINT, 1);
}

void TRIGGERSPIKE01_OnTouch(int id, int charaId)
{
	if (IsItem(charaId))
	{
		if (GetItemString(charaId, ITEM_MODEL) == "boom")
		{
			BombExplode(charaId);
		}
		else if (GetItemString(charaId, ITEM_MODEL) == "Box01")
		{
			BreakItem(charaId, 150);
		}
		return;
	}
	
	CharaHurt(charaId, 1, 200);
}

void SPIKE02_InitItem(int id)
{
	float x, y, z, dx, dy, dz;
	
	GetEntityPos(id, x, y, z);
	GetEntityDir(id, dx, dy, dz);
	
	SetItemAttrib(id, ITEM_MODEL, "in05spike02", 1);
	SetItemAttrib(id, ITEM_PHYSICS, ITEM_PHYSICS_NONE);
	SetItemAttrib(id, ITEM_LIFTABLE, 0);
	SetItemAttrib(id, ITEM_PICKABLE, 0);
	SetItemAttrib(id, ITEM_MOVEPOINT, 2, x, y, z, x-120*dy, y+120*dx, z);
	SetItemAttrib(id, ITEM_WAITTIME, 0);
	SetItemAttrib(id, ITEM_MOVETYPE, 0);
	SetItemAttrib(id, ITEM_MOVESPEED, 20);
	SetItemAttrib(id, ITEM_NEXTPOINT, 1);
}

void SPIKE02_OnReach(int id, int np)
{
	if (np == 0)
	{
		bMachineMoving = 0;
	}
	else if (np == 1)
	{
		ObjectID = FindItem("SPIKE01_00");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("TRIGGERSPIKE01_00");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("SPIKE01_01");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("TRIGGERSPIKE01_01");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("SPIKE02_00");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("TRIGGERSPIKE02_00");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("SPIKE02_01");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("TRIGGERSPIKE02_01");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("SPIKE02_02");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("TRIGGERSPIKE02_02");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("SPIKE02_03");
		SetItemMachine(ObjectID, 1, 0);
		ObjectID = FindItem("TRIGGERSPIKE02_03");
		SetItemMachine(ObjectID, 1, 0);

		ObjectID = FindItem("Switch_02");
		SetItemMachine(ObjectID, 1);
		ObjectID = FindItem("Switch_03");
		SetItemMachine(ObjectID, 1);
	}
}

void TRIGGERSPIKE02_InitItem(int id)
{
	float x, y, z, dx, dy, dz;
	
	GetEntityPos(id, x, y, z);
	GetEntityDir(id, dx, dy, dz);
	
	SetItemAttrib(id, ITEM_SIZE, 160, 100, 180);
	SetItemAttrib(id, ITEM_PHYSICS, ITEM_PHYSICS_NONE);
	SetItemAttrib(id, ITEM_LIFTABLE, 0);
	SetItemAttrib(id, ITEM_PICKABLE, 0);
	SetItemAttrib(id, ITEM_MOVEPOINT, 2, x, y, z, x-120*dy, y+120*dx, z);
	SetItemAttrib(id, ITEM_WAITTIME, 0);
	SetItemAttrib(id, ITEM_MOVETYPE, 0);
	SetItemAttrib(id, ITEM_MOVESPEED, 20);
	SetItemAttrib(id, ITEM_NEXTPOINT, 1);
}

void TRIGGERSPIKE02_OnTouch(int id, int charaId)
{
	if (IsItem(charaId))
	{
		if (GetItemString(charaId, ITEM_MODEL) == "boom")
		{
			BombExplode(charaId);
		}
		else if (GetItemString(charaId, ITEM_MODEL) == "Box01")
		{
			BreakItem(charaId, 150);
		}
		return;
	}
	
	CharaHurt(charaId, 1, 200);
}

